<?php
namespace Claromentis\Core\Event;

$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"] ?: array()) + array("_d91a7be21d" . "972d4aac861" . "a7352a2079f" => base64_decode("c2V0Tm" . "FtZQ=="), "_249e641075c6a29865e4" . "c4b46d959e7f" => base64_decode("dHJpZ2dlcl9kZXBy" . "ZWNhdGlvbg=="), "_db6f0ba0791e9a635407659a9" . "fe04e40" => base64_decode("aXN" . "fb2" . "JqZ" . "WN0"), "_f6ad69e5b7ae7662b1d0fa0" . "5847ada65" => base64_decode("Y2xhcm9tZW50aX" . "MvZnJhbWV3b3Jr"), "_96be32a6f44bf54e635" . "e1736acf7a96c" => base64_decode("c2VyaWFsa" . "Xpl"), "_7cf327515b98333f2887781d258" . "2ce87" => base64_decode("TWV0aG9kIHNpZ25hdHVyZSBkZXByZWNhdGVkIGZvciB0aGUgRXZlbnREaXNwYXRjaGVyOjpkaXNwYXRjaCgpIHNpbmNlIENvcmUgMTAsIGR1ZSB0byBTeW1mb255IDUncyB" . "jaGFuZ2VzOiBzd2FwIHRoZSBmaXJzdCB0d28gYXJndW1lbnRzIHRvIHRoaXMgbWV0aG9k"), "_6edacb78bd55" . "c5015af27c8ac" . "1fcd9af" => base64_decode("bWV0aG9kX2V4aXN0cw" . "=="), "_c244a470df5" . "2d1d5a708513" . "8ec94e393" => base64_decode("dW5z" . "ZXJp" . "YWxp" . "emU="), "_9a9e2d14785bdbae" . "cfc454cb009e47a7" => base64_decode("M" . "T" . "A" . "="));
use Claromentis\Common\ApplicationMiscellany\Finisher;
use Claromentis\Core\Services;
use Symfony\Contracts\EventDispatcher\Event;
use Symfony\Component\EventDispatcher\EventDispatcher as BaseEventDispatcher;




class EventDispatcher extends BaseEventDispatcher implements EventDispatcherInterface
{
    
    
    
    
    
    
    protected ?Finisher $finisher;
    
    
    
    
    public function __construct(Finisher $_fea16585ee8de2b835a68ccd4bc60aef = null)
    {
        parent::__construct();
        $this->finisher = $_fea16585ee8de2b835a68ccd4bc60aef;
    }
    
    
    
    
    
    
    
    
    public static function Shared()
    {
        return Services::I()->dispatcher;
    }
    
    
    
    
    
    
    
    
    
    
    
    public function dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b = null, bool $_46d17db0bd1ac920366ce3e210c240c1 = false) : object
    {
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_db6f0ba0791e9a6354076" . "59a9fe04e40"]($event)) {
            return $this->bcAwareDispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b, $_46d17db0bd1ac920366ce3e210c240c1);
        }
        $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_249e641075c6a29865e4c4b46d95" . "9e7f"]($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_f6ad69e5b7ae76" . "62b1d0fa05847ad" . "a65"], $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_9a9e2d14" . "785bdbaec" . "fc454cb00" . "9e47a7"], $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_7cf327515b9" . "8333f2887781" . "d2582ce87"]);
        return $this->bcAwareDispatch($_2cf093f28f4c7e718a5e8af628894c7b, $event, $_46d17db0bd1ac920366ce3e210c240c1);
    }
    
    
    
    
    
    
    
    
    
    private function bcAwareDispatch(object $event = null, ?string $_2cf093f28f4c7e718a5e8af628894c7b, bool $_46d17db0bd1ac920366ce3e210c240c1 = false) : object
    {
        if ($event === null) {
            $event = new Event();
        }
        if ($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_6edacb78bd55c5015af27c8ac1fcd9a" . "f"]($event, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_d91a7be21d972d4aa" . "c861a7352a2079f"])) {
            $event->setName($_2cf093f28f4c7e718a5e8af628894c7b);
        }
        if (!$_46d17db0bd1ac920366ce3e210c240c1 || !isset($this->finisher)) {
            return parent::dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b);
        } else {
            $_a6a149597bf68ad5294d98abc0bda72b = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_96be32a6f44bf54e635e173" . "6acf7a96c"]($event);
            $this->finisher->FinishHim(function ($request, $_fd5a3a643834299cbdadfc3540ba0bcb) use($_2cf093f28f4c7e718a5e8af628894c7b, $_a6a149597bf68ad5294d98abc0bda72b) {
                $event = $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_c244a470df52d1d5a7" . "085138ec94e393"]($_a6a149597bf68ad5294d98abc0bda72b);
                $this->dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b, false);
            });
            return $event;
        }
    }
}